/***********************************************************************/
/*  A/Dϊ̃VOXL[hgK                      */
/***********************************************************************/

#include "iodefine.h"
#include "typedefine.h"

#define ex1

#define	printf	((int (*)(const char *,...))0x00007c7c)

#define	SW6 (PD.DR.BIT.B18)
#define	SW4 (PD.DR.BIT.B16)

#ifdef ex6
#define  DIG1  (PE.DR.BIT.B3)
#define  DIG2  (PE.DR.BIT.B2)
#define  DIG3  (PE.DR.BIT.B1)
void disp_led(_SINT, _UINT);
#endif

#ifdef ex7
#define LCD_RS		(PA.DR.BIT.B22)
#define LCD_E		(PA.DR.BIT.B23)
#define LCD_RW		(PD.DR.BIT.B23)
#define LCD_DATA	(PD.DR.BYTE.HH)

void wait_us(_UINT);
void LCD_inst(_SBYTE);
void LCD_data(_SBYTE);
void LCD_cursor(_UINT, _UINT);
void LCD_putch(_SBYTE);
void LCD_putstr(_SBYTE *);
void LCD_cls(void);
void LCD_init(void);
#endif

void main(void);

void main(void) {
#ifdef ex1
	STB.CR4.BIT._AD0 = 0;
	AD0.ADCR.BIT.ADST = 1;
	while(AD0.ADCR.BIT.ADST);
	AD0.ADCSR.BIT.ADF = 0;
	printf("ADDR0 = %04d \n", AD0.ADDR0 >> 6);
	while(1);
#endif

#ifdef ex2
	STB.CR4.BIT._AD0 = 0;

#endif

#ifdef ex3
	STB.CR4.BIT._AD0 = 0;

#endif

#ifdef ex4
	STB.CR4.BIT._AD0 = 0;

#endif

#ifdef ex5
	STB.CR4.BIT._AD0 = 0;

#endif

#ifdef ex6
	_UWORD	ad_rst = 0;
	_SINT	keta = 0;
	STB.CR4.BIT._AD0 = 0;
	STB.CR4.BIT._CMT = 0;


#endif
#ifdef ex7
	_UWORD	ad_rst = 0;
	_SBYTE	str[16] = {' ',' ','A','D','D','R','0',' ','=',' ','0','0','0',' ',' ','\0'};
	STB.CR4.BIT._AD0 = 0;
	STB.CR4.BIT._CMT = 0;


#endif

}

#ifdef ex6
void disp_led(_SINT digit, _UINT ad_rst) {
	DIG1 = DIG2 = DIG3 = 0;
	PA.DR.BYTE.HL &= 0xf0;
	if (digit == 0) {
		PA.DR.BYTE.HL |= ad_rst % 10;
		DIG1 = 1;
	} else if (digit == 1) {
		PA.DR.BYTE.HL |= (ad_rst / 10) % 10;
		DIG2 = 1;
	} else {
		PA.DR.BYTE.HL |= (ad_rst / 100) % 10;
		DIG3 = 1;
	}
}
#endif

#ifdef ex7
void wait_us(_UINT us) {
	_UINT val;

	val = us * 10 / 16;
	if (val >= 0xffff)
		val = 0xffff;

	CMT0.CMCOR = val;
	CMT0.CMCSR.BIT.CMF &= 0;
	CMT.CMSTR.BIT.STR0 = 1;
	while (!CMT0.CMCSR.BIT.CMF);
	CMT0.CMCSR.BIT.CMF = 0;
	CMT.CMSTR.BIT.STR0 = 0;
}

void LCD_inst(_SBYTE inst) {
	LCD_E = 0;
	LCD_RS = 0;
	LCD_RW = 0;
	LCD_E = 1;
	LCD_DATA = inst;
	wait_us(1);
	LCD_E = 0;
	wait_us(40);
}

void LCD_data(_SBYTE data) {
	LCD_E = 0;
	LCD_RS = 1;
	LCD_RW = 0;
	LCD_E = 1;
	LCD_DATA = data;
	wait_us(1);
	LCD_E = 0;
	wait_us(40);
}

void LCD_cursor(_UINT x, _UINT y) {
	if (x > 15)
		x = 15;
	if (y > 1)
		y = 1;
	LCD_inst(0x80 | x | y << 6);
}

void LCD_putch(_SBYTE ch) {
	LCD_data(ch);
}

void LCD_putstr(_SBYTE *str) {
	_SBYTE ch;

	while (ch = *str++)
		LCD_putch(ch);
}

void LCD_cls(void) {
	LCD_inst(0x01);
	wait_us(1640);
}

void LCD_init(void) {
	wait_us(45000);
	LCD_inst(0x30);
	wait_us(4100);
	LCD_inst(0x30);
	wait_us(100);
	LCD_inst(0x30);
	
	LCD_inst(0x38);
	LCD_inst(0x08);
	LCD_inst(0x01);
	wait_us(1640);
	LCD_inst(0x06);
	LCD_inst(0x0c);
}
#endif